package plantWar;

import java.awt.*;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

public class MygameFrame extends Frame {

    Image plant = GameUtil.getImage("image/plant.png");
    Image bj = GameUtil.getImage("image/bjt.jpg");

    Plant p = new Plant(30,100,5,plant);


    @Override
    public void paint(Graphics g) {
        g.drawImage(bj,0,0,null);
        p.drawMyself(g);




    }

    public void lunchFrame(){

        setTitle("植物大战僵尸");
        setLocation(200,200);
        setSize(500,370);
        setVisible(true);
////增加关闭窗口监听，这样用户点击右上角关闭图标，可以关闭游戏程序
        addWindowListener(new WindowAdapter() {
            @Override
            public void windowClosing(WindowEvent e) {
                super.windowClosing(e);
                System.exit(0);
            }
        });
        new PaintThread().start();
        this.addKeyListener(new KeyMonitor());

    }


    /**
     * 定义一个重画窗口的线程类，是一个内部类
     */

    class PaintThread extends Thread{

        public void run(){
            while(true){
                repaint();
                try {
                    Thread.sleep(40);
                } catch (InterruptedException e) {
                    e.printStackTrace();
                }
            }
        }
    }
    /**
     * 定义一个键盘监听的类，是一个内部类，实现操控植物
     */
    class KeyMonitor extends KeyAdapter{
        @Override
        public void keyPressed(KeyEvent e) {
            super.keyPressed(e);
            //System.out.println(e.getKeyCode());
            p.addDreaction(e);
        }

        @Override
        public void keyReleased(KeyEvent e) {
            super.keyReleased(e);
            //System.out.println(e.getKeyCode());
            p.mionDreaction(e);
        }
    }
    private Image offScreenImage = null;
    public void update(Graphics g) {
        if(offScreenImage == null)
            offScreenImage = this.createImage(500,500);//这是游戏窗口的宽度和高度
        Graphics gOff = offScreenImage.getGraphics();
        paint(gOff);
        g.drawImage(offScreenImage, 0, 0, null);
    }


    public static void main(String[] args) {

        MygameFrame mygameFrame = new MygameFrame();
        mygameFrame.lunchFrame();
    }
}
